package ds_machine;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
//Evenements est une JFrame
public class Evenements extends JFrame {

	/**
	 * @param args
	 */
	private JComboBox comboBoxFont; //Le choix des polices
	private JTextArea textArea; //La zone de saisie
	private JCheckBox checkBoxItalic, checkBoxBold; //Le choix des styles
	private JColorChooser colorChooser; //Le choix des couleurs
	private JSpinner spinnerSize; //Le choix de la taille
	private JButton buttonExit; //Le bouton quitter

	

	public Evenements(String string) {
		// TODO Auto-generated constructor stub
		super(string); //Une fentre avec un titre
		
		
		this.setDefaultCloseOperation(EXIT_ON_CLOSE); //Comportement lors de la fermeture de la fenetre 
		this.setLayout(new BorderLayout()); //Le gestionnaire de mise en page de la fenetre

		textArea = new JTextArea(10,40); //Creation d'une zone de saisie de 10 colonnes par 40 lignes
		this.add(textArea, BorderLayout.WEST); //La zone de saisie est a l'ouest
		Font textAreaFont; //Declaration d'une fonte
		Color textAreaColor; //Declaration d'une couleur
		textAreaFont =textArea.getFont(); //recuperation de la fonte de la zone de saisie
		textAreaColor = textArea.getForeground(); //recuperation de la couleur du texte de la zone de texte

		/*
		 * creation d'un JPanel avec gestionnaire de mise en page en GridLayout de 2 de haut par 1 de large 
		 * Il contiendra le JColorChooser
		 */
		JPanel panel = new JPanel(new GridLayout(2,1));   
		/*
		 * creation d'un JPanel avec gestionnaire de mise en page en GridLayout de 5 de haut par 1 de large 
		 * Il contiendra la JComboBox, les JCheckBox, le JSpinner, le JButton 
		 */
		JPanel panel2 = new JPanel(new GridLayout(5,1));
		/*
		 * Recuperation des polices logiques de java
		 */
		String[] fontNames = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
		
		/*
		 * i sera le numro de la police de la zone de saisie
		 */
		int i=0;
		while (i < fontNames.length && !fontNames[i].equals(textAreaFont.getName()))
		{	
			i++;
		}
		/*
		 * Creation d'une JComboBox conteanat les polices
		 */
		comboBoxFont = new JComboBox(fontNames);
		/*
		 * La valeur de la selection de la JComboBox est celle de la zone de texte
		 */
		comboBoxFont.setSelectedItem(fontNames[i]);
		
		

		//Ajout de la JComboBox	au panel2
		panel2.add(comboBoxFont);

		//Creation d'un JCheckBox pour le gras
		checkBoxBold = new JCheckBox("Bold");
		//Le JcheckBox est initialis avec la valeur de la zone de saisie
		checkBoxBold.setSelected(textAreaFont.isBold());
		
		
		
		panel2.add(checkBoxBold); //Ajout de la JCheckBox au panel2 

		//Creation d'un JCheckBox pour l'italique
		checkBoxItalic = new JCheckBox("Italic");
		//Le JcheckBox est initialis avec la valeur de la zone de saisie
		checkBoxItalic.setSelected(textAreaFont.isItalic());
		
		
		panel2.add(checkBoxItalic); //Ajout de la JCheckBox au panel2 
		
		/*
		 * Creation d'un JSpinner  partir d'un modele la valeur initiale est la taille de la police de la zone de texte
		 * La valeur minimale est 0
		 * La plus grande valeur est 20
		 * Le pas est de 1
		 */ 
		spinnerSize = new JSpinner(new SpinnerNumberModel(textAreaFont.getSize(),0,20,1));
		
		
		panel2.add(spinnerSize); //Ajout du JSPinner au panel2

		//Creation du bouton quitter
		buttonExit = new JButton("Quitter");
		
		
		panel2.add(buttonExit); //Ajout du bouton au panel2
		panel.add(panel2); //ajout du panel2 au panel
		/*
		*Creation d'un JColorChooser initialis avec la couleur du texte de la zone de saisie 
		*/
		colorChooser = new JColorChooser(textAreaColor); 
		
		
		
		//Ajout du JColorChooser au panel
		panel.add(colorChooser);


		//Ajout du panel  la fenetre  l'est
		this.add(panel, BorderLayout.EAST);

		//Dimensionnement automatique de la fenetre
		this.pack();

	}

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Evenements evenements = new Evenements("Ah que du bonheur");
		evenements.setVisible(true);
	}
	
	//Mthode  completer et  appeler
	public void updateTextArea()
	{
		this.pack(); //Pour redimensionner la fentre en fonction des fontes choisies.
		
	}
	
	
}
